/* minimal replacement of crt0.o provided by C library */

#define zero	$0
#define AT	$1
#define v0 	$2
#define v1	$3
#define a0	$4
#define a1	$5
#define a2	$6
#define	a3	$7

#define t0	$8
#define t1	$9
#define t2	$10
#define t3	$11
#define t4	$12
#define t5	$13
#define t6	$14
#define t7	$15
#define t8	$24
#define t9	$25
#define k0	$26
#define k1	$27

#define s0	$16
#define s1	$17
#define s2	$18
#define s3	$19
#define s4	$20
#define s5	$21
#define s6	$22
#define s7	$23

#define gp	$28
#define sp	$29
#define fp	$30
#define ra	$31

#define SERIAL_PORT_BASE     0xffffc000

#define SERP_RX_ST_REG_o           0x00
#define SERP_RX_ST_REG_READY_m      0x1
#define SERP_RX_ST_REG_IE_m         0x2

#define SERP_RX_DATA_REG_o         0x04

#define SERP_TX_ST_REG_o           0x08
#define SERP_TX_ST_REG_READY_m      0x1
#define SERP_TX_ST_REG_IE_m         0x2

#define SERP_TX_DATA_REG_o         0x0c


.globl _start
.set noat
.set noreorder
.ent _start

.text

_start:

	addi	$1, $0, 0x101
	addi	$2, $0, 0x102
	synci   0(zero)
	addi	$3, $0, 0x103
	addi	$4, $0, 0x104
	la	$20, skip
	mtc0	$20, $14, 0  // EPC
	eret
	addi	$5, $0, 0x105
	addi	$6, $0, 0x106
skip:
	addi	$7, $0, 0x107
	addi	$8, $0, 0x108
	mfc0	$9, $14, 0   // EPC

	break
	mfc0	$10, $14, 0  // EPC

	la	$20, irq_entry - 0x180
	mtc0	$20, $15, 1  // EBase
	
	li	$21, SERIAL_PORT_BASE
	li	$20, SERP_RX_ST_REG_IE_m
	sw	$20, SERP_RX_ST_REG_o($21)
	li	$20, 0x00000801
	mtc0	$20, $12, 0  // Status

loop:	mfc0	$10, $14, 0  // EPC
        beq     zero, zero, loop
	nop


irq_entry:
	mfc0	$26, $13, 0  // Cause
	andi	$27, $26, 0x00000800
	bnez	$27, rx_irq
	nop
	mfc0	$27, $12, 0  // Status
	not	$26, $26
	and	$26, $26, 0x0000ff00
	and     $27, $27, $26
	mtc0	$27, $12, 0  // Status
	eret

rx_irq:
	li	$26, SERIAL_PORT_BASE
	lw	$27, SERP_RX_DATA_REG_o($26)
	sw	$27, SERP_TX_DATA_REG_o($26)
	eret

.end _start
