#define SERIAL_PORT_BASE     0xffffc000

#define SERP_RX_ST_REG_o           0x00
#define SERP_RX_ST_REG_READY_m      0x1
#define SERP_RX_ST_REG_IE_m         0x2

#define SERP_RX_DATA_REG_o         0x04

#define SERP_TX_ST_REG_o           0x08
#define SERP_TX_ST_REG_READY_m      0x1
#define SERP_TX_ST_REG_IE_m         0x2

#define SERP_TX_DATA_REG_o         0x0c


#define	UserLocal  $4,2
#define	BadVAddr   $8
#define	Count	   $9
#define	Compare    $11
#define	Status     $12
#define	Cause      $13
#define	EPC        $14
#define	EBase      $15,1
#define	Config     $16
 
	.text
	.globl	main
	.globl	_start
	.set	noreorder
	.set	noat

_start:
main:
	# allow hardware interrupts
	mfc0	$t0, Status   # get status register
	ori	$t0, $t0, 0x0C01
	mtc0	$t0, Status

	addi	$a0, $zero, 0
	la	$a1, hello
	addi	$a2, $zero, 12
	
	addi	$v0, $zero, 4004  /* SYS_write */
	syscall	

forever:    
	addi	$s0, $s0, 1   # 1,2,3,4,... 
	beq	$0, $0, forever
	nop

#--- END MAIN 


	.data
hello:
	.asciz "Hello world\n"

.section .kdata, "w"

kdata_base:
save0:	.word 0
save1:	.word 0

#define FIFO_SIZE

rx_head:.word	0
rx_tail:.word	0
rx_fifo:.skip	FIFO_SIZE

tx_head:.word	0
tx_tail:.word	0
tx_fifo:.skip	FIFO_SIZE

.section .excpt_handler, "ax"

exception_handler:
	
	la	$k0, kdata_base
	sw	$a0, (save0-kdata_base)($k0)
	sw	$v0, (save0-kdata_base+4)($k0)

	mfc0	$a0, Cause
	andi	$v0, $a0, 0x3c
	beq	$v0, $0, cause_irq
	nop


excpt_ret:
	lw $a0, save0-kdata_base($k0)
	lw $v0, save1-kdata_base($k0)
	eret

cause_irq:	
	andi	$v0, $a0, 0x00000400
	bnez	$v0, tx_irq
	nop
	andi	$v0, $a0, 0x00000800
	bnez	$v0, rx_irq
	nop
	# disable interrupts which are not handled
	mfc0	$v0, Status
	not	$a0, $a0
	and	$a0, $a0, 0x0000f300
	and     $a0, $a0, $v0
	mtc0	$a0, Status
	beq	$0, $0, excpt_ret
	nop

rx_irq:
	li	$26, SERIAL_PORT_BASE
	lw	$27, SERP_RX_DATA_REG_o($26)
	sw	$27, SERP_TX_DATA_REG_o($26)
	eret

		
	
	mtc0 $zero, $13          # Clear Cause register
	mfc0 $k0, Status         # Set Status register
	ori  $k0, 0x1            # Interrupts enabled
	mtc0 $k0, Status
	eret
